config/routes.rb
Rails.application.routes.draw do
  root 'learning_resources#index'  
  resources :quiz_transactions
  resources :learning_resource_transactions
  resources :quiz_questions
  resources :learning_resources
  devise_for :users

  resources :quizzes do
    resources :questions
  end

  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Reveal health status on /up that returns 200 if the app boots with no exceptions, otherwise 500.
  # Can be used by load balancers and uptime monitors to verify that the app is live.
  get "up" => "rails/health#show", as: :rails_health_check
  
  # Defines the root path route ("/")
  # root "posts#index"
end

app/models/learning_resource.rb
class LearningResource < ApplicationRecord
    has_many :learning_resource_transactions
    validates :topic, presence: true
    has_one_attached :thumbnail
end

app/controllers/learning_resources_controller.rb
class LearningResourcesController < ApplicationController
  before_action :set_learning_resource, only: %i[ show edit update destroy ]

  # GET /learning_resources or /learning_resources.json
  def index
    @learning_resources = LearningResource.all
  end

  # GET /learning_resources/1 or /learning_resources/1.json
  def show
    @learning_resource = LearningResource.find(params[:id])
  end

  # GET /learning_resources/new
  def new
    @learning_resource = LearningResource.new
  end

  # GET /learning_resources/1/edit
  def edit
    @learning_resource = LearningResource.find(params[:id])
  end

  # POST /learning_resources or /learning_resources.json
  def create
    @learning_resource = LearningResource.new(learning_resource_params)

    respond_to do |format|
      if @learning_resource.save
        format.html { redirect_to learning_resource_url(@learning_resource), notice: "Learning resource was successfully created." }
        format.json { render :show, status: :created, location: @learning_resource }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @learning_resource.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /learning_resources/1 or /learning_resources/1.json
  def update
    respond_to do |format|
      if @learning_resource.update(learning_resource_params)
        format.html { redirect_to learning_resource_url(@learning_resource), notice: "Learning resource was successfully updated." }
        format.json { render :show, status: :ok, location: @learning_resource }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @learning_resource.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /learning_resources/1 or /learning_resources/1.json
  def destroy
    @learning_resource.destroy!

    respond_to do |format|
      format.html { redirect_to learning_resources_url, notice: "Learning resource was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_learning_resource
      @learning_resource = LearningResource.find(params[:id])
    end

    # Only allow a list of trusted parameters through.
    # def learning_resource_params
    #   params.fetch(:learning_resource, {})
    # end
    def learning_resource_params
      params.require(:learning_resource).permit(:topic, :youtube_link, :knowledge, :thumbnail)
    end
end

app/helpers/learning_resources_helper.rb
module LearningResourcesHelper
end

app/views/learning_resources/_form.html.erb
<%= form_with(model: learning_resource) do |form| %>
  <% if learning_resource.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(learning_resource.errors.count, "error") %> prohibited this learning_resource from being saved:</h2>

      <ul>
        <% learning_resource.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/learning_resources/_learning_resource.html.erb
<div id="<%= dom_id learning_resource %>">
</div>

app/views/learning_resources/edit.html.erb
<h1>Edit Learning Resource</h1>

<%= form_with(model: @learning_resource, local: true, html: { class: "form", multipart: true }) do |form| %>
  <% if @learning_resource.errors.any? %>
    <div id="error_explanation" class="alert alert-danger">
      <h2><%= pluralize(@learning_resource.errors.count, "error") %> prohibited this learning_resource from being saved:</h2>

      <ul>
        <% @learning_resource.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="mb-3">
    <%= form.label :topic, class: "form-label" %>
    <%= form.text_field :topic, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.label :youtube_link, class: "form-label" %>
    <%= form.text_field :youtube_link, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.label :knowledge, class: "form-label" %>
    <%= form.text_area :knowledge, class: "form-control tinymce", rows: 5 %>
  </div>

  <div class="mb-3">
    <%= form.label :thumbnail, class: "form-label" %>
    <%= form.file_field :thumbnail, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.submit "Submit", class: "btn btn-primary" %>
  </div>
<% end %>

<%= link_to "Back to learning resource", learning_resource_path(@learning_resource) %>

app/views/learning_resources/index.html.erb
 <% if user_signed_in? %>
  <h1>Learning resources</h1>
  <div id="learning_resources" class="row">
    <% @learning_resources.each do |learning_resource| %>
      <div class="col-md-4 mb-3">
        <div class="card">

          <% if learning_resource.thumbnail.present? %>
            <%= image_tag learning_resource.thumbnail, class: "card-img-top"  %>
          <% else %>
            <img src="https://2.bp.blogspot.com/-MowVHfLkoZU/VhgIRyPbIoI/AAAAAAAATtI/fHk-j_MYUBs/s640/placeholder-image.jpg" alt="Default Thumbnail" class="card-img-top" />
          <% end %>

          <div class="card-body">
            <h5 class="card-title"><%= learning_resource.topic %></h5>
            <p class="card-text text-truncate" style="max-height: 3.6em; overflow: hidden;">
              Description or other content about the learning resource goes here.
            </p>
            <%= link_to "Show this learning resource", learning_resource, class: "btn btn-primary" %>
          </div>
        </div>
      </div>
    <% end %>
  </div>

  <%= link_to "New learning resource", new_learning_resource_path, class: "btn btn-success" %>
<% else %>

<div class="jumbotron rounded d-flex align-items-center justify-content-center custom-bg" style="height: 80vh; background-size: cover;">
   <div class="gradient-overlay" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; background: linear-gradient(to bottom, rgba(0,0,0,0.4), transparent); pointer-events: none; z-index: 1;"></div>
  <div class="container text-center">
      <h1 style="color: black;">Welcome to the Cultural Quiz Platform</h1>
    <p style="color: black;">Test your knowledge about various cultural topics from around the world. Explore different cultures, traditions, and customs.</p>
    <p><a class="btn btn-primary btn-lg" href="#" role="button">Start Quiz »</a></p>
  </div>
</div>

<% end %>
</div>

app/views/learning_resources/new.html.erb
<%= form_with(model: @learning_resource, local: true, html: { class: "form", multipart: true }) do |form| %>
  <% if @learning_resource.errors.any? %>
    <div id="error_explanation" class="alert alert-danger">
      <h2><%= pluralize(@learning_resource.errors.count, "error") %> prohibited this learning_resource from being saved:</h2>

      <ul>
        <% @learning_resource.errors.full_messages.each do |message| %>
          <li><%= message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div class="mb-3">
    <%= form.label :topic, class: "form-label" %>
    <%= form.text_field :topic, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.label :youtube_link, class: "form-label" %>
    <%= form.text_field :youtube_link, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.label :knowledge, class: "form-label" %>
    <%= form.text_area :knowledge, class: "form-control tinymce", rows: 5 %>
  </div>

  <div class="mb-3">
    <%= form.label :thumbnail, class: "form-label" %>
    <%= form.file_field :thumbnail, class: "form-control" %>
  </div>

  <div class="mb-3">
    <%= form.submit "Submit", class: "btn btn-primary" %>
  </div>
<% end %>

app/views/learning_resources/show.html.erb
<h1 class="mb-4">Topic: <%= @learning_resource.topic %></h1>

<div class="embed-responsive embed-responsive-16by9">
  <iframe class="embed-responsive-item" width="490" height="275" src="<%= @learning_resource.youtube_link %>" frameborder="0" allowfullscreen></iframe>
</div>
<p class="lead"><%= raw @learning_resource.knowledge %></p>

<div class="btn-toolbar mb-2">
  <div style="padding-right: 5px;">
    <%= link_to learning_resources_path, class: "btn btn-secondary" do %>
      <i class="bi bi-arrow-left"></i> Back
    <% end %>
  </div>
  <div style="padding-right: 5px;">
    <%= link_to edit_learning_resource_path(@learning_resource), target: "_blank", class: "btn btn-secondary" do %>
      <i class="bi bi-pencil-fill"></i> Edit
    <% end %>
  </div>
  <div style="padding-right: 5px;">
    <%= button_to(@learning_resource, method: :delete, class: "btn btn-danger", data: { confirm: "Are you sure?" }) do %>
      <i class="bi bi-trash-fill"></i> Delete
    <% end %>
  </div>
</div>